
// Project: webCDwriter - Network CD Writing
// File: Accounts.cpp
// Author: Jrg Haeger, 25.04.2001

#include <stdio.h>
#include <string.h>
#include "Accounts.h"
#include "Config.h"

Accounts::Accounts()
{
	pthread_mutex_init(&mutex, NULL);
}

Accounts::~Accounts()
{
}

void Accounts::add(const char *ID, const char *passwd, const char *eMail)
{
	char ID2[strlen(ID) + 1];
	strcpy(ID2, ID);
	replaceColons(ID2);

	char passwd2[strlen(passwd) + 1];
	strcpy(passwd2, passwd);
	replaceColons(passwd2);

	char eMail2[strlen(eMail) + 1];
	strcpy(eMail2, eMail);
	replaceColons(eMail2);

	try {
		pthread_mutex_lock(&mutex);

		getByID(ID2);
		if (strcmp(id, ID2) == 0)
			throw "ID already in use";

		FILE *out = fopen(config.getAccountsFile(), "a");
		if (out == NULL)
			throw "Cannot write to the accounts file.";
		fprintf(out, "%s:%s:%s\n", ID2, passwd2, eMail2);
		fclose(out);

		pthread_mutex_unlock(&mutex);
	}
	catch (const char *msg) {
		pthread_mutex_unlock(&mutex);
		throw msg;
	}
}

void Accounts::check(const char *ID, const char *passwd)
{
	char ID2[strlen(ID) + 1];
	strcpy(ID2, ID);
	replaceColons(ID2);

	char passwd2[strlen(passwd) + 1];
	strcpy(passwd2, passwd);
	replaceColons(passwd2);

	try {
		pthread_mutex_lock(&mutex);

		getByID(ID2);
		if (strcmp(id, ID2) != 0)
			throw "unknown user";
		else
			if (strcmp(this->passwd, passwd2) != 0)
				throw "invalid password";

		pthread_mutex_unlock(&mutex);
	}
	catch (const char *msg) {
		pthread_mutex_unlock(&mutex);
		throw msg;
	}
}

void Accounts::getByID(const char *ID)
{
	FILE *in = fopen(config.getAccountsFile(), "r");
	if (in == NULL)
		throw "Cannot open the accounts file.";

	while (fgets(lineStr, sizeof lineStr, in) != NULL)
	{
		if (sscanf(lineStr, "%[^:]:%[^:]:%[^:]",
			id, passwd, eMail) != 3)
			continue;
		if (strcmp(id, ID) == 0)
			break;
	}
	fclose(in);
}

char *Accounts::replaceColons(char *str)
{
	char *ptr = str;
	while (*ptr != 0)
	{
		if (*ptr == ':')
			*ptr = '_';
		ptr++;
	}
	return str;
}

Accounts *accounts;
