
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

public class BurnSelectDialog extends Dialog
{
	public BurnSelectDialog()
	{
		super("BurnSelectDialogTitle");

		JPanel panel = new JPanel()
		{
			public Insets getInsets() {
				return new Insets(10, 10, 10, 10);
			}
		};
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));

		panel.add(createSelectionGroup());

		getContentPane().add(panel, BorderLayout.CENTER);
		getContentPane().add(createControlPanel(),
			BorderLayout.SOUTH);
		pack();
	}

	protected boolean apply()
	{
		if (currentButton.isSelected())
		{
			Mode.source = Mode.current;
			return true;
		}
		else
		if (otherButton.isSelected())
		{
			String ID = IDField.getText();
			String p = passwordField.getText();
			if (ID.length() == 0
				|| p.length() == 0)
			{
				JOptionPane.showMessageDialog(
					CDcreator.mainWin,
					i18n("BurnSelectDialogCannotOpenSession"),
					i18n("error"),
					JOptionPane.ERROR_MESSAGE);
				return false;
			}
			GetSessionInfo info = new GetSessionInfo();
			info.run(ID, p);
			if (info.numOfTracks == 0)
			{
				JOptionPane.showMessageDialog(
					CDcreator.mainWin,
					i18n("BurnSelectDialogCannotOpenSession2"),
					i18n("error"),
					JOptionPane.ERROR_MESSAGE);
				return false;
			}
			Command.sessionID = ID;
			Command.sessionPassword = p;
			Mode.source = Mode.server;
			if (info.numOfFiles > 0)
			{
				Mode.type = Mode.data;
				Mode.image = true;
			}
			else
				Mode.image = false;
			return true;
		}
		else
		if (copyButton.isSelected())
		{
			Mode.source = Mode.copy;
			return true;
		}
		return false;
	}

	protected JPanel createInputGroup()
	{
		JPanel p = new JPanel();
		p.setLayout(new BoxLayout(p, BoxLayout.Y_AXIS));
		p.setBorder(
			BorderFactory.createEmptyBorder(3, 40, 5, 5));
		p.setAlignmentX(LEFT_ALIGNMENT);

		IDField = new JTextField(Command.sessionID);
		IDField.setColumns(10);
		tab = 300;
		p.add(createLabelItemBox(
			new JLabel(i18n("BurnSelectDialogID")),
			IDField));
//		p.add(Box.createVerticalStrut(5));

		passwordField = new JPasswordField(Command.sessionPassword);
		passwordField.setColumns(10);
		p.add(createLabelItemBox(
			new JLabel(i18n("BurnSelectDialogPassword")),
			passwordField));

		return p;
	}

	protected JPanel createSelectionGroup()
	{
		JPanel p = new JPanel();
		p.setLayout(new BoxLayout(p, BoxLayout.Y_AXIS));
		p.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));

		JComponent c = new JLabel(i18n("BurnSelectDialogInfo"));
		c.setAlignmentX(LEFT_ALIGNMENT);
		p.add(c);
		p.add(Box.createVerticalStrut(10));

		currentButton = new JRadioButton(
			i18n("BurnSelectDialogCurrentSession"));
		currentButton.setAlignmentX(LEFT_ALIGNMENT);
		p.add(currentButton);

		otherButton = new JRadioButton(
			i18n("BurnSelectDialogOtherSession"));
		otherButton.setAlignmentX(LEFT_ALIGNMENT);
		p.add(otherButton);

		IDPanel = createInputGroup();
		p.add(IDPanel);
		otherButton.addChangeListener(new ChangeListener()
		{
			public void stateChanged(ChangeEvent e)
			{
				IDPanel.setEnabled(otherButton.isSelected());
			}
		});
		IDPanel.setEnabled(other);

		copyButton = new JRadioButton(
			i18n("BurnSelectDialogCopy"));
		copyButton.setAlignmentX(LEFT_ALIGNMENT);
		copyButton.setEnabled(CDcreator.copySupport);
		p.add(copyButton);

		ButtonGroup g = new ButtonGroup();
		g.add(currentButton);
		g.add(otherButton);
		g.add(copyButton);
		currentButton.setSelected(true);

		return p;
	}

	private static boolean other = false;
	JPanel IDPanel;
	JRadioButton currentButton, otherButton, copyButton;
	JTextField IDField, passwordField;
}
