
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

public class SessionIDDialog extends Dialog
{
	public SessionIDDialog()
	{
		super("SessionIDDialogTitle");

		JPanel panel = new JPanel()
		{
			public Insets getInsets() {
				return new Insets(10, 10, 10, 10);
			}
		};
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));

		panel.add(createSelectionGroup());

		getContentPane().add(panel, BorderLayout.CENTER);
		getContentPane().add(createControlPanel(),
			BorderLayout.SOUTH);
		pack();
	}

	protected boolean apply()
	{
		Mode.store = storeButton.isSelected();
		if (!Mode.store)
			return true;

		String ID = IDField.getText();
		String a = passwordField.getText();
		String b = passwordField2.getText();
		if (ID.length() == 0)
		{
			JOptionPane.showMessageDialog(
				CDcreator.mainWin,
				i18n("SessionIDDialogNoID"),
				i18n("error"),
				JOptionPane.ERROR_MESSAGE);
			return false;
		}
		else
		if (a.length() == 0)
		{
			JOptionPane.showMessageDialog(
				CDcreator.mainWin,
				i18n("SessionIDDialogNoPassword"),
				i18n("error"),
				JOptionPane.ERROR_MESSAGE);
			return false;
		}
		else
		if (!a.equals(b))
		{
			JOptionPane.showMessageDialog(
				CDcreator.mainWin,
				i18n("SessionIDDialogDiffer"),
				i18n("error"),
				JOptionPane.ERROR_MESSAGE);
			return false;
		}
		else
		{
			Command.sessionID = ID;
			Command.sessionPassword = a;
			return true;
		}
	}

	protected JPanel createInputGroup()
	{
		JPanel p = new JPanel();
		p.setLayout(new BoxLayout(p, BoxLayout.Y_AXIS));
		p.setBorder(
			BorderFactory.createEmptyBorder(3, 40, 5, 5));
//		p.setPreferredSize(new Dimension(250, 80));
		p.setAlignmentX(LEFT_ALIGNMENT);

		IDField = new JTextField(Command.sessionID);
		IDField.setColumns(10);
		tab = 300;
		p.add(createLabelItemBox(
			new JLabel(i18n("SessionIDDialogID")),
			IDField));
		p.add(Box.createVerticalStrut(10));

		passwordField = new JPasswordField(Command.sessionPassword);
		passwordField.setColumns(10);
		p.add(createLabelItemBox(
			new JLabel(i18n("SessionIDDialogPassword")),
			passwordField));

		passwordField2 = new JPasswordField(Command.sessionPassword);
		passwordField2.setColumns(10);
		p.add(createLabelItemBox(
			new JLabel(i18n("SessionIDDialogRepeat")),
			passwordField2));

		return p;
	}

	protected JPanel createSelectionGroup()
	{
		JPanel p = new JPanel();
		p.setLayout(new BoxLayout(p, BoxLayout.Y_AXIS));
		p.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));

		JComponent c = new JLabel(i18n("SessionIDDialogInfo"));
		c.setAlignmentX(LEFT_ALIGNMENT);
		p.add(c);
		p.add(Box.createVerticalStrut(10));

		JRadioButton noButton = new JRadioButton(
			i18n("SessionIDDialogNo"));
		noButton.setAlignmentX(LEFT_ALIGNMENT);
		p.add(noButton);

		storeButton = new JRadioButton(i18n("SessionIDDialogYes"));
		storeButton.setAlignmentX(LEFT_ALIGNMENT);
		p.add(storeButton);

		userPanel = createInputGroup();
		p.add(userPanel);
		storeButton.addChangeListener(new ChangeListener()
		{
			public void stateChanged(ChangeEvent e)
			{
				userPanel.setEnabled(storeButton.isSelected());
			}
		});
		userPanel.setEnabled(Mode.store);

		ButtonGroup g = new ButtonGroup();
		g.add(noButton);
		g.add(storeButton);
		noButton.setSelected(!Mode.store);
		storeButton.setSelected(Mode.store);

		return p;
	}

	JPanel userPanel;
	JRadioButton storeButton;
	JTextField IDField, passwordField, passwordField2;
}
